###############################################################################
# Résolution d'une équation du premier ordre par la méthode d'Euler explicite #
###############################################################################

from pylab import *

# données 1 : caractéristiques du système
K=1       # gain
tau=0.1   # constante de temps en s

# données 2 : paramètres de calcul
h=0.01    # pas de temps (secondes)
n=100     # nombre de points de calcul

# définition de l'entrée
def e(t):
    return 1

# formulation de Cauchy
# définition de l'équadiff sous la forme f'(t)=...
# e est la fonction de t définie préalablement
# s est la sortie à calculer
def eqdf(s,t):
    return (1/tau)*(K*e(t)-s)

# création des listes T et S des instants et des valeurs de la sortie
# et initialisation
T=[0]
S=[0]

# résolution par le schéma d'Euler explicite :
for i in range(n):
    T.append(T[i]+h)
    S.append(S[i]+h*eqdf(S[i],T[i]))

# affichage de s(t)
plot(T,S)
grid()
show()

